<template>
  <div class="box p-3">
    <div v-if="notifications.data.length === 0" class="flex justify-center items-center h-40 text-base">
      No notifications yet!
    </div>
    <div v-else>
      <div v-if="user.unread_notification_count" class="mb-5">
        <Link href="/notification/read-all" as="button" class="action-btn" method="put">Read all ({{
          user.unread_notification_count }})</Link>
      </div>

      <div class="divide-y">
        <div class="flex gap-x-3 p-2 items-center" v-for="notification in notifications.data">
          <div class="flex-1">
            <div class="block text-base">
              <!-- TYPES -->
              <div v-if="notification.type === 'App\\Notifications\\UserRegistered'">
                A new user
                <Link class="link" :href="`/employee/user/${notification.data.user_id}`">({{ notification.data.role_name
                }}) {{ notification.data.user_name }}</Link> is registered!
              </div>
              <div v-if="notification.type === 'App\\Notifications\\UserDeleted'">
                User
                <Link class="link" :href="`/employee/user/${notification.data.user_id}`">({{ notification.data.role_name
                }}) {{ notification.data.user_name }}</Link> is deleted!
              </div>
              <div v-if="notification.type === 'App\\Notifications\\LeaveApproved'">
                Your
                <Link class="link" :href="`/leave/leaveApplication/${notification.data.leave_application_id}`">{{
                  notification.data.leave_type }} Application</Link> from {{ notification.data.start_date }} to {{
                  notification.data.end_date }} is
                <Status status="Approved" />
              </div>
              <div v-if="notification.type === 'App\\Notifications\\LeaveRejected'">
                Your
                <Link class="link" :href="`/leave/leaveApplication/${notification.data.leave_application_id}`">{{
                  notification.data.leave_type }} Application</Link> from {{ notification.data.start_date }} to {{
                  notification.data.end_date }} is
                <Status status="Rejected" />
              </div>
              <div v-if="notification.type === 'App\\Notifications\\FormFilledOut'">
                <Link class="link" :href="`/form/filledForm/${notification.data.id}`">{{
                  notification.data.name }}</Link> is filled out for ({{ notification.data.role_name
                }}) {{ notification.data.user_name }}
              </div>
              <div v-if="notification.type === 'App\\Notifications\\FormShared'">
                <Link class="link" :href="`/form/sharedForm/${notification.data.id}`">{{
                  notification.data.name }}</Link> for ({{ notification.data.role_name
                }}) {{ notification.data.user_name }} is shared with you
              </div>
              <div v-if="notification.type === 'App\\Notifications\\FormApproved'">
                Your
                <Link class="link" :href="`/form/filledForm/${notification.data.id}`">{{
                  notification.data.name }}</Link> is
                <Status status="Approved" />
              </div>
              <div v-if="notification.type === 'App\\Notifications\\FormRejected'">
                Your
                <Link class="link" :href="`/form/filledForm/${notification.data.id}`">{{
                  notification.data.name }}</Link> is
                <Status status="Rejected" />
              </div>
              <div v-if="notification.type === 'App\\Notifications\\ObservationMade'">
                An
                <Link class="link" :href="`/performance/myPerformance/${notification.data.id}`">
                <span :class="notification.data.type === 'Appreciation Note' ? 'text-lime-500' : 'text-red-600'">({{
                  notification.data.type }})</span> Observation</Link> is made for you by {{
                    notification.data.observer_name
                }} ({{ notification.data.observer_role }})
              </div>
            </div>

            <div class="flex gap-x-5">
              <div>
                <Icon icon="fa-solid fa-calendar" class="text-base mr-2 text-gray-400"></Icon>
                <span class="text-sm font-semibold text-gray-400">{{ new
                  Date(notification.created_at).toLocaleDateString() }}</span>
              </div>
              <div>
                <Icon icon="fa-solid fa-clock" class="text-base mr-2 text-gray-400"></Icon>
                <span class="text-sm font-semibold text-gray-400">{{ new
                  Date(notification.created_at).toLocaleTimeString() }}</span>
              </div>
            </div>
          </div>

          <Link :href="`/notification/${notification.id}/read`" v-if="!notification.read_at" class="action-btn"
            as="button" method="put">Read</Link>
          <div v-else class="text-base text-gray-600">
            <Icon icon="fa-solid fa-check"></Icon>
            Seen
          </div>
        </div>
      </div>
    </div>
  </div>

  <Pagination :data="notifications"></Pagination>
</template>

<script setup>
import Pagination from '@/Components/Pagination.vue';
import Status from '@/Components/Status.vue';
import { Link, usePage } from '@inertiajs/vue3';
import { computed } from 'vue';

defineProps({
  notifications: Object
})

const page = usePage();
const user = computed(() => page.props.currentUser)
</script>